/******************************************************************************
 *
 *                Copyright (c) 2017-2019 by Löwenware Ltd
 *             Please, refer LICENSE file for legal information
 *
 ******************************************************************************/

/**
 * @file mod-feedback.h
 * @author Ilja Kartašov <ik@lowenware.com>
 * @brief AISL feedback module header file
 *
 * @see https://lowenware.com/aisl/
 */

#ifndef FEEDBACK_H_6CC516E4_A7F2_4A9D_B467_75DCF6F58108
#define FEEDBACK_H_6CC516E4_A7F2_4A9D_B467_75DCF6F58108

#include <mods/context.h>
#include <mods/module.h>
#include <components/mail.h>

struct ax_feedback_cfg {
	struct ax_mail_smtp smtp;
	const char *end_point;
	const char *name_email;
	const char *name_msg;
	const char *mail_subject;
	const char *mail_from;
	const char *mail_to;
};


struct ax_feedback {
	struct ax_module root;
	struct ax_mail_smtp smtp;
	const char *name_email;
	const char *name_msg;
	const char *mail_subject;
	const char *mail_from;
	const char *mail_to;
	uint16_t   name_email_length;
	uint16_t   name_msg_length;
};


typedef struct ax_feedback * AxFeedback;


AislStatus
ax_feedback_init(AxFeedback mod, const struct ax_feedback_cfg *cfg);


void
ax_feedback_release(AxFeedback mod);

#endif /* !FEEDBACK_H */
